<?php

/* 
 * Requires fping; a simple one page tool that periodically pings the
 * stored host IPs and records when they change between an up/down state
 * only, this isn't for measuring latency just basic host reachability
 */


	$mysqli_db=mysqli_connect("localhost","pingtest","6U28LPRd5AcXdKhc","pingtest") or
	 die("Error " . mysqli_error($mysqli_db)); 


    // When called via CLI, pass the option "fping" to ping the stored hosts
	if($argv[1]=="fping")
	{

		// Select all the enabled hosts
		$hosts_query="SELECT Host ".
					 "FROM Hosts ".
					 "WHERE Host_Enabled = 1";

		$hosts_query_results=mysqli_query($mysqli_db, $hosts_query);

		if (!$hosts_query_results) 
		 die("Couldn't get list of ping hosts: ".mysqli_errno($mysqli_db)." ".
		 	 mysqli_error($mysqli_db));


        // Build up the fping CLI string to ping all the enabled hosts
		$fping_path="/usr/local/sbin/fping";
		$fping_hosts="";

		while($host_row=mysqli_fetch_assoc($hosts_query_results))
		{
			$fping_hosts.=" ".$host_row['Host'];
		}

		$fping_cmd = "sudo ".$fping_path." ".$fping_hosts;
	    exec($fping_cmd, $fping_output, $fping_retval);


        // Check the fping results and see if this result differents from the last
	    $index=0;
	    while($index<count($fping_output))
	    {

	        $host_result = preg_split('/\s+/', $fping_output[$index]);

	        if($host_result[2]=="alive")
	        {
	        	$result=1;
	        	echo "Host ".$host_result[0]." is alive\n";
	        } else {
	        	$result=0;
	        	echo "Host ".$host_result[0]." is unavailable\n";
	        }

	        $host_id_query="SELECT PK_Host_ID FROM Hosts ".
	        			   "WHERE Host = '".$host_result[0]."'";

			$host_id_query_result=mysqli_query($mysqli_db, $host_id_query);

			if (!$host_id_query_result) 
			 die("Couldn't get host ID for host ".$host_result[0].": ".
			 	 mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));
			$host_id=mysqli_fetch_assoc($host_id_query_result);

			$last_result_query="SELECT Result FROM Results ".
							   "WHERE Host_ID = '".$host_id['PK_Host_ID']."' ".
							   "ORDER BY Result_Datetime Desc LIMIT 0,1";

			$last_result_query_result=mysqli_query($mysqli_db, $last_result_query);

			if (!$last_result_query_result) 
			 die("Couldn't get last result for host ID ".$host_id['PK_Host_ID'].
			 	 ": ".mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));

			if(mysqli_num_rows($last_result_query_result)>0)
			{

				$last_result=mysqli_fetch_assoc($last_result_query_result);

                // This host has changed up/down state so the new result needs storing
				if($last_result['Result']!=$result)
				{
			        $result_query="INSERT INTO Results ".
			        			  "(`PK_Result_ID`, `Host_ID`, `Result`, ".
			        			  "`Result_Datetime`) VALUES ".
					              "(NULL, '".$host_id['PK_Host_ID']."', '".
					              $result."', NOW())";
					$result_query_results=mysqli_query($mysqli_db, $result_query);

					if (!$result_query_results) 
					 die("Couldn't add new result for host ID ".
					 	 $host_id['PK_Host_ID'].": ".mysqli_errno($mysqli_db).
					 	 " ".mysqli_error($mysqli_db));
				}
			
			// This is the first result for this host
			} elseif(mysqli_num_rows($last_result_query_result)==0) {

		        $result_query="INSERT INTO Results ".
		        			  "(`PK_Result_ID`, `Host_ID`, `Result`, `Result_Datetime`) VALUES ".
				              "(NULL, '".$host_id['PK_Host_ID']."', '".$result."', NOW())";

				$result_query_results=mysqli_query($mysqli_db, $result_query);

				if (!$result_query_results) 
				 die("Couldn't add new result for host ID ".$host_id['PK_Host_ID'].
				 	 ": ".mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));

			}


			$index+=1;

	    }

	    die();
	}


    // Convert 1/0 to ASCII "Enabled"/"Disabled"
	function host_enabled($enabled)
	{

		if($enabled==1)
		{
			return "Enabled";
		} else {
			return "Disabled";
		}

	}


    // Convert 1/0 to ASCII "Success"/"Failed"
	function result_check($result)
	{

		if($result==1){
			return "Success";
		} else {
			return "Failed";
		}

	}

?>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>

	<meta http-equiv="Content-type" content="text/html;charset=UTF-8"/>
	<meta http-equiv="refresh" content="300;url='<? echo $_SERVER['PHP_SELF']; ?>'">

	<style type="text/css">
		body
		{
			font-family: Georgia, "Times New Roman", Times, serif;
		}
		table
		{
			margin: 10px;
		}
		th
		{
			text-align: center;
			font-weight: bold
		}
		td
		{
			text-align: center;
			padding: 4px;
		}
		.td-blank
		{
			background-color: #FFFFFF;
		}
		.headings
		{
			font-weight: normal;
			font-size: x-large
		}
		.last-success
		{
			background-color: #CAFFD8;
		}
		.last-failed
		{
			background-color: #FF7575;
		}
		.table-row {
   	 		display: visible;
		}
	</style>

	<script type="text/javascript">

		function confirm_delete(hostid, host)
		{
		    if(hostid=='' || hostid==' ' || host=='' || host==' ')
		    {
		        alert('Oh pants! Cant delete host, missing data!');
		        return false;
		    }

		    var page = '<? echo basename(__FILE__); ?>';
		    var answer = confirm('Are you sure you want to delete the host to "'+host+
		                         '"? (All results for this host will be deleted)');
		    if (answer) {
		        window.location.href = page+'?action=deletehost&hostid='+
		                               hostid+'&host='+host;
		    }
		}

		function toggle_row(rowtitle)
		{
    		var tr = document.getElementsByTagName('tr');
   			for (var i=0; i<tr.length; i++)
   			{
      			if (tr[i].title==rowtitle)
      			{
            		if (tr[i].style.display=='none')
            		{
                		tr[i].style.display='table-row';
            		} else {
              	  		tr[i].style.display='none';
           	 		}
       	 		}
    		}
		}

	</script>

</head>

<body>

<?

    // Add new hosts to be periodically ping'ed
    if(isset($_POST['action']) && $_POST['action']=="addhosts" && 
       isset($_POST['hosts']) && $_POST['hosts']!= "")
    {

        $New_Hosts = preg_split("/[\s,]+/", $_POST['hosts']);
        if(count($New_Hosts)>0)
        {

			echo "<div>\n";

            $i=0;
        	while($i<count($New_Hosts))
        	{

        		if(strlen($New_Hosts[$i])>6)
        		{

	        		$check_host_query="SELECT Host FROM Hosts ".
	        		                   "WHERE Host = '".$New_Hosts[$i]."'";
	        		                   echo $check_hosts_query;

	        		$check_host_query_results=mysqli_query($mysqli_db, $check_host_query);

					if (!$check_host_query_results) 
					 die("Couldn't check list of existing ping hosts: ".
					 	 mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));

					if (mysqli_num_rows($check_host_query_results)>0)
						die("Host already exists: ".$New_Hosts[$i]);


		            $add_host_query="INSERT INTO Hosts ".
		                       "(`PK_Host_ID`, `Host`, `Host_Enabled`, `Host_Added`) ".
		                       "VALUES ".
		                       "(NULL, '".$New_Hosts[$i]."', 1, NOW())";

		            $add_host_query_results=mysqli_query($mysqli_db, $add_host_query);

					if (!$add_host_query_results) 
					 die("Couldn't add list of ping hosts: ".mysqli_errno($mysqli_db).
					 	 " ".mysqli_error($mysqli_db));

					echo "<p>Added host ".$New_Hosts[$i]."</p>\n";

		        }

		        $i+=1;

           }

           	echo "</div>\n";

        }

    }


    // Delete host from periodic pings
    if(isset($_GET['action']) && $_GET['action']=="deletehost" &&
       isset($_GET['hostid']) && $_GET['hostid']!=="")
    {
    	
    	$delete_host_query="DELETE FROM Hosts ".
    	                   "WHERE PK_Host_ID = '".$_GET['hostid']."'";
	    $delete_host_query_results=mysqli_query($mysqli_db, $delete_host_query);
		if (!$delete_host_query_results) 
			die("Couldn't delete host ".$_GET['host'].": ".mysqli_errno($mysqli_db).
				" ".mysqli_error($mysqli_db));

		echo "<div><p>Deleted host ".$_GET['host']."</p></idv>";

    	$delete_results_query="DELETE FROM Results ".
    	                     "WHERE Host_ID = '".$_GET['hostid']."'";
    	$delete_results_query_results=mysqli_query($mysqli_db, $delete_results_query);
		if (!$delete_results_query_results) 
			die("Couldn't delete results for host ".$_GET['hostid'].": ".
				mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));

    }


    $hosts_query="SELECT * FROM Hosts";
	$hosts_query_results=mysqli_query($mysqli_db, $hosts_query);

	if (!$hosts_query_results) 
	 die("Couldn't get list of ping hosts: ".mysqli_errno($mysqli_db)." ".
	 	 mysqli_error($mysqli_db));


   // From here onwards the code is displaying the HTML page, form and any existing results

?>

	<form method="post" action="<? echo basename(__FILE__); ?>" id="newhosts">

		<table>

			<thead>
				<tr>
					<th style="text-align: left;">Add new ping host (seperated by space, tab, comma or new line)</th>
				</tr>
			</thead>

			<tbody>
			    <tr>
			    	<td style="text-align: left;"><textarea name="hosts" id="hosts" cols="50" rows="10"></textarea></td>
			    </tr>
			    <tr>
			    	<td style="text-align: left;">
			    		<input type="hidden" name="action" id="action" value="addhosts"/>
			    		<input type="submit" value="Add"/>
			    	</td>
			    </tr>
			</tbody>

		</table>

	</form>


<?
		if(mysqli_num_rows($hosts_query_results)>0)
		{
?>

	<table>

		<caption class="headings">Results</caption>
		<thead>
			<tr>
				<th></th>
				<th>Host</th>
				<th>Enabled</th>
				<th>Last Result</th>
				<th>Last Change</th>
				<th></th>
			</tr>
		</thead>

		<tbody>

<?
			while($hosts_row=mysqli_fetch_assoc($hosts_query_results))
			{

				$results_query="SELECT * FROM Results ".
				               "WHERE Host_ID = '".$hosts_row['PK_Host_ID']."' ".
				               "ORDER BY Result_Datetime Desc";

		        $results_query_results=mysqli_query($mysqli_db, $results_query);

				if (!$results_query_results) 
				 die("Couldn't get list of results for host ID ".$hosts_row[PK_Host_ID].": ".
				 	 mysqli_errno($mysqli_db)." ".mysqli_error($mysqli_db));

				$last_result=mysqli_fetch_assoc($results_query_results);
				

				if($last_result['Result']==1)
				{ 
					echo "<tr class=\"last-success\">\n";
				} else {
					echo "<tr class=\"last-failed\">\n";
				}


				echo "<td><a href=\"javascript:toggle_row('row".$hosts_row['PK_Host_ID']."');\">".
				         "<img src=\"detail24x24.png\"/></a></td>".
				     "<td>".$hosts_row['Host']."</td>".
				     "<td>".host_enabled($hosts_row['Host_Enabled'])."</td>".
				     "<td>".result_check($last_result['Result'])."</td>".
				     "<td>".$last_result['Result_Datetime']."</td>".
				     "<td><a href=\"javascript:confirm_delete('".$hosts_row['PK_Host_ID']."','".$hosts_row['Host']."');\">".
				         "<img src=\"delete24x24.png\"/></a></td>\n".
				     "</tr>\n";

				mysqli_data_seek($results_query_results, 0);
				while($results_row=mysqli_fetch_assoc($results_query_results))
				{

					if($results_row['Result']==1)
					{ 
						echo "<tr title=\"row".$results_row['Host_ID']."\" style=\"display: none;\" ".
							 "class=\"last-success\">\n";
					} else {
						echo "<tr title=\"row".$results_row['Host_ID']."\" style=\"display: none;\" ".
							 "class=\"last-failed\">\n";
					}

					echo "<td class=\"td-blank\"></td><td class=\"td-blank\"></td><td class=\"td-blank\"></td>".
						 "<td>".result_check($results_row['Result'])."</td>".
					     "<td>".$results_row['Result_Datetime']."</td>".
					     "<td class=\"td-blank\"></td>\n".
					     "</tr>\n";

				}

			}
?>

		 </tbody>
		 
	</table>

<?		 
		}
?>

</body>

</html>